<?php 

namespace Controller;

defined('ROOTPATH') OR exit('Access Denied!');

/**
 * video class
 */
use \Core\Request;
use \Core\Session;

class Video
{
	use MainController;

	public function index()
	{
		$ses = new Session;
		$req = new Request;
		$video = new \Model\Video;
		$playlist = new \Model\Playlist;
		
		if($ses->user('role') != 'admin')
			redirect('login');

		$data['playlists'] = $playlist->query("select * from playlists");

		$this->view('video',$data);
	}

}
